<template lang="pug">
  .color-picker
    .swatch(v-if="isSwatch")
      picker(v-model="calculatedColor")
    .colors(v-else)
      .main-colors(v-if="type === TYPE_TEXT_COLOR_PICKER")
        .color.double-size(
          v-on:click="color = '#000000'"
          style="background-color: #000000"
          title="#000000"
        )
        .column
          .color(
            v-on:click="color = '#4b4c4e'"
            style="background-color: #4b4c4e"
            title="#4b4c4e"
          )
          .color(
            v-on:click="color = '#95999a'"
            style="background-color: #95999a"
            title="#95999a"
          )
        .color.double-size.border(
          v-on:click="color = '#ffffff'"
          style="background-color: #ffffff"
          title="#ffffff"
        )
      .color(
        v-for="hex in colors"
        v-bind:style="{ 'background-color': hex }"
        v-on:click="color = hex"
        v-bind:title="hex"
      )
    .footer
      input(v-model="color" tabindex="-1")
      .spacer
      img.icon(
        src="~static/vue-static/swatch.png"
        v-if="!isSwatch"
        v-on:click="isSwatch = true"
        v-tooltip:right="'Select from swatch'"
      )
      .colors-icon(
        v-else
        v-on:click="isSwatch = false"
        v-tooltip:right="'Select from predefined colors'"
      )
        .color(style="background-color: red")
        .color(style="background-color: green")
        .color(style="background-color: #f800ff")
        .color(style="background-color: blue")

</template>

<script>
import stageService from '../services/stage'
import config from '../config'
import swatchIcon from '../static/vue-static/swatch.png'

const DEFAULT_COLOR = '#000000'

export default {
  name: 'ColorPicker',
  components: {
    'picker': () => import('vue-color').then(({ Chrome }) => Chrome)
  },
  props: {
    type: {
      default: '',
      type: String
    },
    initialColor: {
      default: '',
      type: String
    }
  },
  data () {
    let colors

    // Set colors for defined type
    switch (this.type) {
      case stageService.TYPE_TEXT_COLOR_PICKER:
        colors = config.colors.hardColors
        break
      default:
        colors = config.colors.softColors
        break
    }

    return {
      isSwatch: false,
      swatchIcon,
      calculatedColor: this.initialColor || DEFAULT_COLOR,
      color: this.initialColor || DEFAULT_COLOR,
      colors,
      TYPE_TEXT_COLOR_PICKER: stageService.TYPE_TEXT_COLOR_PICKER
    }
  },
  watch: {
    color: function () {
      if (this.color) {
        this.calculatedColor = this.color
        this.$emit('select', stageService.hexToRgba(this.color))
      }
    },
    calculatedColor: function () {
      if (this.calculatedColor.hex) {
        const rgba = this.calculatedColor.rgba
        if (this.calculatedColor.rgba.a !== 1) {
          this.color = `rgba(${rgba.r},${rgba.g},${rgba.b},${rgba.a})`
        } else {
          this.color = this.calculatedColor.hex
        }
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  .color-picker {
    width: 244px;
    position: relative;
    background-color: #fff;
    box-shadow: 0 0 2px #aaa;

    .swatch {
      min-height: 262px;
    }

    .vc-chrome {
      font-family: inherit;
      -webkit-box-shadow: none;
      box-shadow: none;
      width: auto;
      height: 262px;
    }

    .main-colors {
      display: flex;
      flex-direction: row;
      padding-bottom: 10px;
    }

    .colors {
      padding: 22px 22px 0 22px;
      display: flex;
      flex-direction: row;
      flex-wrap: wrap;
    }

    .column {
      display: flex;
      flex-direction: column;
    }

    .color {
      width: 34px;
      height: 34px;
      margin: 3px;
      cursor: pointer;

      &.double-size {
        width: 74px;
        height: 74px;
      }

      &.border {
        border: 1px solid #ccc;

        &.double-size {
          width: 72px;
          height: 72px;
        }
      }
    }

    .icon {
      width: 29px;
      height: 29px;
    }

    .colors-icon {
      cursor: pointer;
      display: flex;
      flex-direction: row;
      flex-wrap: wrap;
      width: 28px;
      height: 29px;
      justify-content: space-between;

      .color {
        width: 13px;
        height: 13px;
        margin: 0;
      }
    }

    .footer {
      padding: 11px 25px 25px 22px;
      display: flex;
      flex-direction: row;
      width: 100%;

      input {
        margin: 0 0 0 3px;
        padding: 5px;
        font-size: 14px;
        width: 147px;
        text-transform: uppercase;
        font-weight: bold;
        border: 1px solid #ccc;
      }

      .icon {
        cursor: pointer;
      }
    }
  }
</style>
